#include <stdio.h>
#include <string.h>
#include <assert.h>

#define COMMENT_START "aldec_t_off"
#define COMMENT_END   "aldec_t_on"

#define ALDEC_COMMENT 1
#define SYNOPSYS_COMMENT 2

extern FILE *yyin,*yyout;

int RemoveAldecComments(void)
  {
  FILE *cleanfile=yyout;
  char line[16384];
  int comment=0;


  assert(cleanfile);
  if(!yyin)
    return -1;
  assert(!fseek(yyin,0L,SEEK_SET));
  while(fgets(line,16383,yyin))
    if(line[0]=='#')
      {
      if(comment)
        {
        switch(comment)
          {
          case ALDEC_COMMENT:
            if(strstr(line,COMMENT_END))
              comment=0;
            break;
          case SYNOPSYS_COMMENT:
            if(strstr(line,"synopsys") && strstr(line,"translate_on"))
              comment=0;
            break;
          }
        }
      else
        {
        if(strstr(line,COMMENT_START))
          comment=ALDEC_COMMENT;
        else
          if(strstr(line,"synopsys") && strstr(line,"translate_off"))
            comment=SYNOPSYS_COMMENT;

        if( !comment)
          fprintf(cleanfile,"%s",line);
        }
      }
    else
      if(!comment)
        fprintf(cleanfile,"%s",line);
  fflush(cleanfile);  
  return 0;
  }


int AppendNewLine(void)
  {
#if 1
  FILE *cleanfile=tmpfile();
#else
  FILE *cleanfile=fopen("kupa.txt","wt");
#endif
  char line[16384];

  while(fgets(line,16383,yyin))
    fputs(line,cleanfile);
  fprintf(cleanfile,"\n");
  
  fclose(yyin);
  yyin=cleanfile;
  fflush(yyin);
  assert(!fseek(yyin,0L,SEEK_SET));
  return 0;
  }
