#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

int anytoint(const char *str, unsigned base, int *result)
  {
  int i,j;
  char *conv_error,  *cleanstr=strdup(str);

  i=j=0;
  while(str[i])
    {
    if(str[i]=='_')
      {
      i++;
      continue;
      }
    cleanstr[j++]=str[i++];
    }
  cleanstr[j]='\0';
  *result=(int)strtol( cleanstr, &conv_error, base);
  free(cleanstr);
/*
  if(conv_error)
    if(*conv_error)
      return -1;
*/
  return  0;
  }

char* anytobin(const char *str, unsigned base)
  {
  char *result, tmpresult[33];
  int value;
  int i, j, result_size;
/*
  for( i=0; i<32; i++)
    result[i]='0';
  result[32]='\0';
*/
  if( anytoint( str, base, &value))
    return NULL;
  itoa( value, tmpresult, 2);
  if( (result_size=strlen(tmpresult))>33)
    return NULL;
  result=(char *)malloc(33*sizeof(char));
  for( i=0; i<33; i++)
    result[i]='0';
  for(i=result_size, j=32; i>=0; i--)
    result[j--]=tmpresult[i];
  return result;
  }

char* hextobin(const char *str)
  {
  return anytobin( str, 16);
  }

char* octtobin(const char *str)
  {
  return anytobin( str, 8);
  }


char* bithextobin(const char *str)
  {
  int i, size=0;
  char *result;
  char *hextab[]={"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111",
                  "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"
                 };
  i=0;
  while(str[i])
    if(str[i++]=='_')
      continue;
    else
      size++;
  size*=4;
  result=(char *)calloc(size+1,sizeof(char));
  i=0;
  while(str[i])
    switch(tolower(str[i++]))
      {
      case '_': i++;
                continue;
      case '0': strcat(result,hextab[0]);
                break;
      case '1': strcat(result,hextab[1]);
                break;
      case '2': strcat(result,hextab[2]);
                break;
      case '3': strcat(result,hextab[3]);
                break;
      case '4': strcat(result,hextab[4]);
                break;
      case '5': strcat(result,hextab[5]);
                break;
      case '6': strcat(result,hextab[6]);
                break;
      case '7': strcat(result,hextab[7]);
                break;
      case '8': strcat(result,hextab[8]);
                break;
      case '9': strcat(result,hextab[9]);
                break;
      case 'a': strcat(result,hextab[10]);
                break;
      case 'b': strcat(result,hextab[11]);
                break;
      case 'c': strcat(result,hextab[12]);
                break;
      case 'd': strcat(result,hextab[13]);
                break;
      case 'e': strcat(result,hextab[14]);
                break;
      case 'f': strcat(result,hextab[15]);
                break;
      }
  return result;
  }

char* bitocttobin(const char *str)
  {
  int i, size=0;
  char *result;
  char *octtab[]={"000", "001", "010", "011", "100", "101", "110", "111"
                 };
  i=0;
  while(str[i])
    if(str[i++]=='_')
      continue;
    else
      size++;
  size*=3;
  result=(char *)calloc(size+1,sizeof(char));
  i=0;
  while(str[i])
    switch(str[i++])
      {
      case '_': i++;
                continue;
      case '0': strcat(result,octtab[0]);
                break;
      case '1': strcat(result,octtab[1]);
                break;
      case '2': strcat(result,octtab[2]);
                break;
      case '3': strcat(result,octtab[3]);
                break;
      case '4': strcat(result,octtab[4]);
                break;
      case '5': strcat(result,octtab[5]);
                break;
      case '6': strcat(result,octtab[6]);
                break;
      case '7': strcat(result,octtab[7]);
                break;
      }
  return result;
  }

char* bitbintobin(const char *str)
  {
  int i, size=0;
  char *result;
  char *bintab[]={"0", "1"
                 };
  i=0;
  while(str[i])
    if(str[i++]=='_')
      continue;
    else
      size++;
  result=(char *)calloc(size+1,sizeof(char));
  i=0;
  while(str[i])
    switch(str[i++])
      {
      case '_': i++;
                continue;
      case '0': strcat(result,bintab[0]);
                break;
      case '1': strcat(result,bintab[1]);
                break;
      }
  return result;
  }

char *chartobin(int value)
  {
  char str[3];
  sprintf(str,"%02x",value);
  return bithextobin(str);
  }
