#include <stdio.h>
#include <assert.h>
#include <string.h>
#define GLOBAL_VARIABLES
#include "vhdllex.h"

#define YY_DECL int VHDLscanner( void)
extern FILE *yyin, *yyout;

int ScanMultipleFiles();

int main( int argc, char *argv[])
  {

  if( argc<1)
    {
    printf("Usage:\n%s <id file name> <constant file name>\n", argv[0]);
    return 1;
    }

  idfile=fopen(argv[1],"wt");
//  printf("Przed otwarciem pliku z identyfikatorami\n");
  if(!idfile)
    {
    printf("Can not open file: %s\n", argv[1]);
    return 1;
    }
//  printf("Przed otwarciem pliku ze stalymi\n");
  consfile=fopen(argv[2],"wt");
  if(!consfile)
    {
    printf("Can not open file: %s\n", argv[2]);
    return 1;
    }
  /* Inserting information about types that should be
   * predefined in std_logic_1164
   */
//  printf("Przed zapisem predefiniowanych identyfikatorow\n");
  InsertPredefinedIds();
#if 1
  /* 
   * Inserting information about predefined attributes
   * into idfile
   */
//  printf("Przed zapisem predefiniowanych atrybutow\n");
  InsertPredefinedAttributes();
  /*
   * Insert predefined boolean constants: false/true
   */
//  printf("Przed zapisem predefiniowanych stalych\n");
  InsertPredefinedConstants();
  /*
   * Information about: rising_edge, faling_edge
   */
//  printf("Przed zapisem predefiniowanych zboczy\n");
  InsertPredefinedEdgeFuctions();
  /*
   * Information about some characters: nul, soh etc.
   */
  InsertPredefinedCharacterConstants();
#endif
  GetLastLexemNumber();
  ScanMultipleFiles();
  printf("Lexical scanner passed input files.\n");
//         "File %s is parsing ready.\n", argv[1], argv[2]);
 /* PutLastLexemNumber();*/
//  fclose(consfile);
//  fclose(idfile);
  return 0;
  }


int ScanMultipleFiles()
  {
  char actroot[256], bufor[256], infile[256];
  FILE *designf;
  int len;
  designf=fopen("design.dgn", "rt");
  assert(designf);
  while(fgets(bufor, 256, designf))
    {
    //printf("Inside ScanMultipleFiles: bufor=%s\n",bufor);
    len=strlen(bufor)-5;
    strncpy(actroot, bufor, len);
    actroot[len]='\0';
    //printf("Inside ScanMultipleFiles: actroot=%s\n",bufor);
    sprintf(input_file_info.name,"%s.vhd",actroot);
    sprintf(infile, "..\\%s.vhd", actroot);
    //printf("Inside ScanMultipleFiles: infile=%s\n",bufor);
    yyin=fopen( infile, "rt");
    if(!yyin)
      {
      printf("Can not open input file: %s\n", infile);
      return 1;
      }
    sprintf(infile, "%s.rdr", actroot);
    yyout=fopen(infile,"wt");
    if(!yyout)
      {
      printf("Can not open output file: %s\n", infile);
      return 1;
      }
    input_file_info.line=0;
    AppendNewLine();
    //printf("Inside ScanMultipleFiles: before VHDLscanner\n");
    VHDLscanner(); 
    //printf("Inside ScanMultipleFiles: after VHDLscanner\n");
    fclose(yyout);
    fclose(yyin);

    sprintf(infile, "%s.lex", actroot);
    yyout=fopen(infile,"wt");
    if(!yyout)
      {
      printf("Can not open output file: %s\n", infile);
      return 1;
      }

    sprintf(infile, "%s.rdr", actroot);
    yyin=fopen(infile,"rt");
    if(!yyin)
      {
      printf("Can not open output file: %s\n", infile);
      return 1;
      }
    RemoveAldecComments();
    fclose(yyin);
    fclose(yyout);
    }
  return 0;
  }
