#include <stdlib.h>
#include <string.h>
#include "stack.h"

int stack_push( stack_id *stack, int val, char *str)
  {
  stack_element *new_element=(stack_element*)malloc(sizeof(stack_element));
  if( !new_element)
    return ALLOCATION_ERROR;
  new_element->prev=(*stack);
  new_element->val=val;
  new_element->str=strdup(str);
  *stack=new_element;
  return OK;
  }

int stack_pop( stack_id *stack, int *val, char *str)
  {
  stack_element *old_top=(*stack);
  if( !(*stack))
    return EMPTY_STACK;
  *val=(*stack)->val;
  strcpy( str, (*stack)->str);
  *stack=(*stack)->prev;
  free(old_top);
  return OK;
  }

int stack_find( stack_id *stack, int *val, char *str, int ignore)
  {
  stack_element *tmp_top=(*stack);
  if( !(*stack))
    return NOT_FOUND;
  *val=0;

  if(ignore==IGNORE_CASE)
    {
    while(tmp_top!=NULL)
      if(stricmp( str, tmp_top->str))
        tmp_top=tmp_top->prev;
      else
        {
        *val=tmp_top->val;
        return OK;
        }
    }
  else
    {
    while(tmp_top!=NULL)
      if(strcmp( str, tmp_top->str))
        tmp_top=tmp_top->prev;
      else
        {
        *val=tmp_top->val;
        return OK;
        }
    }

  return NOT_FOUND;
  }