#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include "vhdllex.h"
#include "err_msg.h"


#define MSG_FILE_NAME "..\\errmsg.txt"
#define ERR_FILE_NAME "errors.log"

static FILE *msgfile, *errfile;

int ErrorMsg( int errcode, char *localmsg)
  {
  char line[16384], *msg;

  assert(msgfile=fopen(MSG_FILE_NAME,"rt"));
  errfile=fopen(ERR_FILE_NAME,"at");
  if(!errfile)
	assert(errfile=fopen(ERR_FILE_NAME,"wt"));
  while(fgets(line,16383,msgfile))
	{
	int code;
	char *pos;
	if(!sscanf(line,"%d",&code))
	  continue;
	if( code!=errcode)
	  continue;
	fclose(msgfile);
	for( msg=line; !isalpha(*msg) && *msg; msg++)
	  ;
	pos=strchr(msg,'\n');
	*pos='\0';
	if( !localmsg)
	  fprintf(errfile,"%d %s file: <%s> line <%d>\n", 
	          errcode, msg, input_file_info.name, input_file_info.line);
	else
	  fprintf(errfile,"%d %s %s file: <%s> line <%d>\n", 
	          errcode, msg, localmsg, input_file_info.name, input_file_info.line);
	fclose(errfile);
	return 0;
	}
  fclose(msgfile);
  fprintf(errfile,"%d %s file: <%s> line <%d>\n", errcode, 
	      (localmsg==NULL ? "Unknown error" : localmsg), 
	      input_file_info.name, input_file_info.line);
  fclose(errfile);
  return 0;
  }