-- ACS for initial decoder - unit in ACS 
-- designer rafal wilkowski
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity constout is	  
	port (
		clk: in std_logic;-- common clock
		reset: in std_logic;-- asynchronus reset 
		bit_in: in std_logic_vector (3 downto 0);-- transmition values input from canal
		acs2err0: out std_logic_vector (63 downto 0);-- error state 0
		acs2err1: out std_logic_vector (63 downto 0)-- error state 1
		);
end constout;

architecture constout of constout is
	
begin
	
	process (clk, reset)	
		
		--difference between real values and theoretical values for first four path 	
		
		constant value : std_logic_vector (255 downto 0) := "0101100001010010010110000101001001010010010110000101001001011000100001010010010110000101001001010010010110000101001001011000010100100101100001010010010110000101100001010010010110000101001001010101001001011000010100100101100001011000010100100101100001010010";
		-- for difference between 00
		-- "01","01","10","00","01","01","00","10",
		-- "01","01","10","00","01","01","00","10",
		-- "01","01","00","10","01","01","10","00",
		-- "01","01","00","10","01","01","10","00",
		-- -- for difference between 10
		-- "10","00","01","01","00","10","01","01",
		-- "10","00","01","01","00","10","01","01",
		-- "00","10","01","01","10","00","01","01",
		-- "00","10","01","01","10","00","01","01",
		-- -- for difference between 01
		-- "00","10","01","01","10","00","01","01",
		-- "00","10","01","01","10","00","01","01",
		-- "10","00","01","01","00","10","01","01",
		-- "10","00","01","01","00","10","01","01",
		-- -- for difference between 11
		-- "01","01","00","10","01","01","10","00",
		-- "01","01","00","10","01","01","10","00",
		-- "01","01","10","00","01","01","00","10",
		-- "01","01","10","00","01","01","00","10"
		-- );
		
	begin 	
		
		if (reset = '1') then 
			
			acs2err0 <= (others => '0');
			acs2err1 <= (others => '0');
		elsif (clk'event and clk = '1') then
			
			--choose valid difference vectors				
			
			case bit_in (3 downto 2) is
				when "00" =>
				acs2err0 <= value(255 downto 192);
				when "10" =>
				acs2err0 <= value(191 downto 128);
				when "01" =>
				acs2err0 <= value(127 downto 64);
				when others =>
				acs2err0 <= value(63 downto 0);
			end case;
			case bit_in (1 downto 0) is
				when "00" =>
				acs2err1 <= value(255 downto 192);
				when "10" =>
				acs2err1 <= value(191 downto 128);
				when "01" =>
				acs2err1 <= value(127 downto 64);
				when others =>
				acs2err1 <= value(63 downto 0);
			end case;
			
		end if; 
	end process;	
end;

